Index: src/core/common/tsp_common_ssei.h
===================================================================
--- src/core/common/tsp_common_ssei.h	(révision 4)
+++ src/core/common/tsp_common_ssei.h	(révision 205)
@@ -62,7 +62,7 @@
  * @param[in] value value of the extended info
  * @return the new ei
  */
-TSP_extended_info_t*
+_EXPORT_TSP_COMMON TSP_extended_info_t*
 TSP_EI_new(const char *key,const char *value);
 
 /**
@@ -70,7 +70,7 @@
  * @param[in] ei ei to destruct
  * @return  TSP_STATUS_OK if ok
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_EI_delete(TSP_extended_info_t** ei);
 
 /**
@@ -81,7 +81,7 @@
  * @param[in] value the value of the extended information
  * @return TSP_STATUS_OK on success 
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_EI_initialize(TSP_extended_info_t* ei, const char* key, const char* value);
 
 /**
@@ -92,7 +92,7 @@
  * @param[in] value the value of the extended information
  * @return TSP_STATUS_OK on success 
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_EI_update(TSP_extended_info_t* ei, const char* key, const char* value);
 
 /**
@@ -101,7 +101,7 @@
  *                be allocated but the field may not
  * @return TSP_STATUS_OK on success 
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_EI_finalize(TSP_extended_info_t* ei);
 
 /**
@@ -110,7 +110,7 @@
  * @param[in]     src_EI  source
  * @return TSP_STATUS_OK on success 
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_EI_copy(TSP_extended_info_t* dest_EI, const TSP_extended_info_t src_EI);
 
 /**
@@ -118,7 +118,7 @@
  * @param[in] len length of the eil
  * @return the new eil
  */
-TSP_extended_info_list_t*
+_EXPORT_TSP_COMMON TSP_extended_info_list_t*
 TSP_EIList_new(int32_t len);
 
 /**
@@ -126,7 +126,7 @@
  * @param[in] eil eil to destruct
  * @return  TSP_STATUS_OK if ok
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_EIList_delete(TSP_extended_info_list_t** eil);
 
 /**
@@ -139,7 +139,7 @@
  * @param[in] len the length of the extended info list
  * @return TSP_STATUS_OK on success 
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_EIList_initialize(TSP_extended_info_list_t* eil, const int32_t len);
 
 /**
@@ -147,7 +147,7 @@
  * @param[in,out] eil the extended info list structure
  * @return TSP_STATUS_OK on success 
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_EIList_finalize(TSP_extended_info_list_t* eil);
 
 /**
@@ -156,7 +156,7 @@
  * @param[in] key the key of the extended information to look for 
  * @return a TSP_extended_info_t if found else NULL 
  */
-const TSP_extended_info_t*
+_EXPORT_TSP_COMMON const TSP_extended_info_t*
 TSP_EIList_findEIByKey(const TSP_extended_info_list_t* eil, const char* key);
 
 /**
@@ -165,7 +165,7 @@
  * @param[in]     eil_src  source list
  * @return TSP_STATUS_OK on success 
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_EIList_copy(TSP_extended_info_list_t* eil_dest,
 		const TSP_extended_info_list_t eil_src);
 
@@ -175,7 +175,7 @@
  * @param[in] nei number of extended info
  * @return the new ssei
  */
-TSP_sample_symbol_extended_info_t*
+_EXPORT_TSP_COMMON TSP_sample_symbol_extended_info_t*
 TSP_SSEI_new(const int32_t pgi, const int32_t nei);
 
 /**
@@ -183,7 +183,7 @@
  * @param[in] ssei ssei to destruct
  * @return TSP_STATUS_OK if ok
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_SSEI_delete(TSP_sample_symbol_extended_info_t** ssei);
 
 /**
@@ -193,7 +193,7 @@
  * @param[in] nei the number of extended informations to be attached to this PGI
  * @return TSP_STATUS_OK on success 
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_SSEI_initialize(TSP_sample_symbol_extended_info_t* ssei, const int32_t pgi, const int32_t nei);
 
 /**
@@ -201,7 +201,7 @@
  * @param[in,out] ssei struct to destroy
  * @return TSP_STATUS_OK on success 
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_SSEI_finalize(TSP_sample_symbol_extended_info_t* ssei);
 
 /**
@@ -210,7 +210,7 @@
  * @param[in]     ssei_src  source 
  * @return TSP_STATUS_OK on success 
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_SSEI_copy(TSP_sample_symbol_extended_info_t* ssei_dest,
   	      const TSP_sample_symbol_extended_info_t ssei_src);
 
@@ -219,7 +219,7 @@
  * @param[in] len length of the sseil
  * @return the new sseil
  */
-TSP_sample_symbol_extended_info_list_t*
+_EXPORT_TSP_COMMON TSP_sample_symbol_extended_info_list_t*
 TSP_SSEIList_new(int32_t len);
 
 /**
@@ -227,7 +227,7 @@
  * @param[in] ssei_list  sseil to destruct
  * @return  TSP_STATUS_OK if ok
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_SSEIList_delete(TSP_sample_symbol_extended_info_list_t** ssei_list);
 
 /**
@@ -236,7 +236,7 @@
  * @param[in]     len length of the list
  * @return TSP_STATUS_OK on success 
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_SSEIList_initialize(TSP_sample_symbol_extended_info_list_t* ssei_list,int32_t len);
 
 /**
@@ -244,7 +244,7 @@
  * @param[in,out] ssei_list list to destroy
  * @return TSP_STATUS_OK on success 
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_SSEIList_finalize(TSP_sample_symbol_extended_info_list_t* ssei_list);
 
 /**
@@ -253,12 +253,12 @@
  * @param[in] src_ssei_list source list
  * @return TSP_STATUS_OK on success 
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_SSEIList_copy(TSP_sample_symbol_extended_info_list_t* dest_ssei_list,
                   const TSP_sample_symbol_extended_info_list_t src_ssei_list);
 
 
-TSP_extended_info_list_t*
+_EXPORT_TSP_COMMON TSP_extended_info_list_t*
 TSP_SSEIList_getEIList(const TSP_sample_symbol_extended_info_list_t SSEIList, uint32_t index);
 
 END_C_DECLS
Index: src/core/common/tsp_common_as.h
===================================================================
--- src/core/common/tsp_common_as.h	(révision 4)
+++ src/core/common/tsp_common_as.h	(révision 205)
@@ -69,7 +69,7 @@
  * @param[in] status
  * @return the new TSP_answer_sample_t
  */
-TSP_answer_sample_t*
+_EXPORT_TSP_COMMON TSP_answer_sample_t*
 TSP_AS_new(int32_t version_id,
 	   uint32_t channel_id,
 	   int32_t p_timeout,
@@ -83,9 +83,9 @@
 /**
  * Delete an Answer Sample.
  * @param[in] as  pointer to pointer to the Answer Sample to be destroy
- * return  TSP_STATUS_OK if ok
+ * @return  TSP_STATUS_OK if ok
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_AS_delete(TSP_answer_sample_t** as);
 
 /**
@@ -100,9 +100,9 @@
  * @param[in] max_consumer_number the maximum number of consumer the provider is able to handle.
  * @param[in] current_consumer_number the current number of connected consumer.
  * @param[in] status the TSP STATUS of the answer.
- * return  TSP_STATUS_OK if ok
+ * @return  TSP_STATUS_OK if ok
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_AS_initialize(TSP_answer_sample_t* as,
 		  int32_t version_id,
 		  uint32_t channel_id,
@@ -117,9 +117,9 @@
 /**
  * Destroy the content of an Answer Sample.
  * @param[in,out] as the Answer Sample whose content should be destroyed.
- * return  TSP_STATUS_OK if ok
+ * @return  TSP_STATUS_OK if ok
  */
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_AS_finalize(TSP_answer_sample_t* as);
 
 /** @} */
Index: src/core/common/tsp_encoder.h
===================================================================
--- src/core/common/tsp_encoder.h	(révision 4)
+++ src/core/common/tsp_encoder.h	(révision 205)
@@ -38,7 +38,7 @@
 #ifndef _TSP_ENCODER_H
 #define _TSP_ENCODER_H
 
-#include <tsp_abs_types.h>
+#include <tsp_prjcfg.h>
 #include <tsp_rpc.h>
 
 /**
@@ -198,7 +198,7 @@
  * @param[in] type data type to encode.
  * @return The data type encoder function
  */
-TSP_data_encoder_t TSP_data_channel_get_encoder(TSP_datatype_t type);
+_EXPORT_TSP_COMMON TSP_data_encoder_t TSP_data_channel_get_encoder(TSP_datatype_t type);
 
 /** @} */
 
Index: src/core/common/tsp_common.c
===================================================================
--- src/core/common/tsp_common.c	(révision 4)
+++ src/core/common/tsp_common.c	(révision 205)
@@ -43,3 +43,9 @@
 #include <tsp_const_def.h>
 #define TSP_COMMON_C
 #include <tsp_common.h>
+
+#ifdef WIN32
+    #define assert(exp)     ((void)0)
+#else
+    #include <assert.h>
+#endif
\ Pas de fin de ligne à la fin du fichier.
Index: src/core/common/tsp_common_status.c
===================================================================
--- src/core/common/tsp_common_status.c	(révision 4)
+++ src/core/common/tsp_common_status.c	(révision 205)
@@ -44,6 +44,13 @@
 #include <tsp_common_macros.h>
 #define TSP_COMMON_STATUS_C
 #include <tsp_common_status.h>
+#ifdef WIN32
+    #include <stdio.h>
+    #define snprintf	(int) _snprintf
+    #define assert(exp)     ((void)0)
+#else
+    #include <assert.h>
+#endif
 
 #define TSP_STATUS_MSG_MAX_LENGTH 1024
 
Index: src/core/common/tsp_common.h
===================================================================
--- src/core/common/tsp_common.h	(révision 4)
+++ src/core/common/tsp_common.h	(révision 205)
@@ -48,6 +48,8 @@
 #include <tsp_common_ssei.h>
 #include <tsp_common_as.h>
 
+BEGIN_C_DECLS
+
 /**
  * @defgroup TSP_CommonLib TSP Common Library
  * @ingroup TSP_CoreLib
@@ -58,7 +60,7 @@
  */
 
 #ifdef TSP_COMMON_C
-const int tsp_type_size[] = { 0,
+_EXPORT_TSP_COMMON const int tsp_type_size[] = { 0,
 			      sizeof(double),
 			      sizeof(float),
 			      sizeof(int8_t),
@@ -74,7 +76,7 @@
 			      sizeof(uint8_t),
 			      0				
 };
-const char* tsp_type_name[] = { "TSP_TYPE_UNKNOWN",
+_EXPORT_TSP_COMMON const char* tsp_type_name[] = { "TSP_TYPE_UNKNOWN",
 				"TSP_TYPE_DOUBLE",
 				"TSP_TYPE_FLOAT",
 				"TSP_TYPE_INT8",
@@ -90,7 +92,7 @@
 				"TSP_TYPE_RAW",
 				"TSP_TYPE_LAST"
 };
-const char* tsp_type_fmt[] = { "TSP_TYPE_UNKNOWN",
+_EXPORT_TSP_COMMON const char* tsp_type_fmt[] = { "TSP_TYPE_UNKNOWN",
 			       "%1.15G",
 			       "%1.15G",
 			       "%d",
@@ -107,16 +109,14 @@
 			       "TSP_TYPE_LAST"	
 };
 #else
-extern const int   tsp_type_size[];
-extern const char* tsp_type_name[];
-extern const char* tsp_type_fmt[];
+_EXTERN_TSP_COMMON const int   tsp_type_size[];
+_EXTERN_TSP_COMMON const char* tsp_type_name[];
+_EXTERN_TSP_COMMON const char* tsp_type_fmt[];
+#undef _EXTERN_TSP_COMMON
 #endif
 
-BEGIN_C_DECLS
-
+END_C_DECLS
 
 /** @} */
 
-END_C_DECLS
-
 #endif /* _TSP_COMMON_H */
Index: src/core/common/tsp_common_status.h
===================================================================
--- src/core/common/tsp_common_status.h	(révision 4)
+++ src/core/common/tsp_common_status.h	(révision 205)
@@ -55,10 +55,10 @@
 
 BEGIN_C_DECLS
 
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_STATUS_print(FILE* fs, int32_t TSPStatus);
 
-int32_t
+_EXPORT_TSP_COMMON int32_t
 TSP_STATUS_sprint(char* buffer, int32_t buffer_len, int32_t TSPStatus);
 
 /** @} */
Index: src/core/common/tsp_common_request.c
===================================================================
--- src/core/common/tsp_common_request.c	(révision 4)
+++ src/core/common/tsp_common_request.c	(révision 205)
@@ -44,6 +44,12 @@
 #define TSP_COMMON_REQUEST_C
 #include <tsp_common_request.h>
 
+#ifdef WIN32
+    #define assert(exp)     ((void)0)
+#else
+    #include <assert.h>
+#endif
+
 void TSP_request_create(TSP_request_t* req, TSP_request_type_t req_type) {
   assert(req);
   req->version_id = TSP_PROTOCOL_VERSION;
Index: src/core/common/tsp_decoder.c
===================================================================
--- src/core/common/tsp_decoder.c	(révision 4)
+++ src/core/common/tsp_decoder.c	(révision 205)
@@ -35,7 +35,7 @@
 -----------------------------------------------------------------------
  */
 
-
+#include <rpc/rpc.h>
 #include <rpc/types.h>
 #include <rpc/xdr.h>
  
@@ -44,6 +44,12 @@
 #include <tsp_simple_trace.h>
 #include <tsp_decoder.h>
 
+#ifdef WIN32
+    #define assert(exp)     ((void)0)
+    #include <malloc.h>
+#else
+    #include <assert.h>
+#endif
 
 int32_t TSP_data_channel_double_decoder(void* out_double, uint32_t dimension,  char* in_buf)
 {
@@ -75,11 +81,10 @@
     ((uint64_t*)out_double)[i] = TSP_DECODE_DOUBLE_TO_UINT64(in_buf+(i*TSP_SIZEOF_ENCODED_DOUBLE));   
     STRACE_DEBUG(("decoded DOUBLE = %f, (received) encoded DOUBLE=0x%08llx",((double*)out_double)[i],((uint64_t*)in_buf)[i]));
   }
-  
-  return TRUE;
-
 #endif
 
+  return TRUE;
+
 }
 
 int32_t TSP_data_channel_float_decoder(void* out_float, uint32_t dimension,  char* in_buf)
@@ -112,16 +117,15 @@
 
     ((uint32_t*)out_float)[i] = TSP_DECODE_FLOAT_TO_UINT32(in_buf+(i* TSP_SIZEOF_ENCODED_FLOAT));   
   }
-  
+#endif
   return TRUE;
 
-#endif
 }
 
 int32_t TSP_data_channel_int8_decoder(void* out_int8, uint32_t dimension,  char* in_buf)
 {
   uint32_t i;
-  int32_t out_temp[dimension];
+  int32_t* out_temp = alloca(sizeof(int32_t)*dimension);
 
 
   if(TSP_data_channel_int32_decoder((void *)(&out_temp[0]), dimension, in_buf))
@@ -142,7 +146,7 @@
 {
 
   uint32_t i;
-  int32_t out_temp[dimension];
+  int32_t* out_temp = alloca(sizeof(int32_t)*dimension);
 
 
   if(TSP_data_channel_int32_decoder((void *)(&out_temp[0]), dimension, in_buf))
@@ -191,9 +195,8 @@
     ((int32_t*)out_int32)[i] = TSP_DECODE_INT32(in_buf+(i * TSP_SIZEOF_ENCODED_INT32));   
   }
   
-  return TRUE;
-
 #endif
+    return TRUE;
 }
 
 int32_t TSP_data_channel_int64_decoder(void* out_int64, uint32_t dimension,  char* in_buf)
@@ -226,16 +229,15 @@
 
     ((int64_t*)out_int64)[i] = TSP_DECODE_INT64(in_buf+(i * TSP_SIZEOF_ENCODED_INT64));   
   }
-  
-  return TRUE;
-
+ 
 #endif
+    return TRUE;
 }
 
 int32_t TSP_data_channel_uint8_decoder(void* out_uint8, uint32_t dimension,  char* in_buf)
 {
   uint32_t i;
-  int32_t out_temp[dimension];
+  int32_t* out_temp = alloca(sizeof(int32_t)*dimension);
 
 
   if(TSP_data_channel_int32_decoder((void *)(&out_temp[0]), dimension, in_buf))
@@ -255,7 +257,7 @@
 int32_t TSP_data_channel_uint16_decoder(void* out_uint16, uint32_t dimension,  char* in_buf)
 {
   uint32_t i;
-  int32_t out_temp[dimension];
+  int32_t* out_temp = alloca(sizeof(int32_t)*dimension);
 
 
   if(TSP_data_channel_int32_decoder((void *)(&out_temp[0]), dimension, in_buf))
@@ -303,9 +305,8 @@
     ((uint32_t*)out_uint32)[i] = TSP_DECODE_UINT32(in_buf+(i * TSP_SIZEOF_ENCODED_UINT32));   
   }
   
-  return TRUE;
-
 #endif
+  return TRUE;
 }
 
 int32_t TSP_data_channel_uint64_decoder(void* out_uint64, uint32_t dimension,  char* in_buf)
@@ -339,16 +340,15 @@
     ((uint64_t*)out_uint64)[i] = TSP_DECODE_UINT64(in_buf+(i * TSP_SIZEOF_ENCODED_UINT64));   
   }
   
-  return TRUE;
-
 #endif
+  return TRUE;
 }
 
 int32_t TSP_data_channel_char_decoder(void* out_char, uint32_t dimension,  char* in_buf)
 {
 
   uint32_t i;
-  int32_t out_temp[dimension];
+  int32_t* out_temp = alloca(sizeof(int32_t)*dimension);
 
 
   if(TSP_data_channel_int32_decoder((void *)(&out_temp[0]), dimension, in_buf))
@@ -369,7 +369,7 @@
 {
 
   uint32_t i;
-  int32_t out_temp[dimension];
+  int32_t* out_temp = alloca(sizeof(int32_t)*dimension);
 
 
   if(TSP_data_channel_int32_decoder((void *)(&out_temp[0]), dimension, in_buf))
@@ -390,7 +390,7 @@
 {
 
   uint32_t i;
-  int32_t out_temp[dimension];
+  int32_t* out_temp = alloca(sizeof(int32_t)*dimension);
 
 
   if(TSP_data_channel_int32_decoder((void *)(&out_temp[0]), dimension, in_buf))
Index: src/core/common/tsp_common_request.h
===================================================================
--- src/core/common/tsp_common_request.h	(révision 4)
+++ src/core/common/tsp_common_request.h	(révision 205)
@@ -69,7 +69,7 @@
 } TSP_request_type_t;
 
 #ifdef TSP_COMMON_REQUEST_C
-const char* tsp_reqname_tab[] = {"tsp_request_invalid",
+_EXPORT_TSP_COMMON const char* tsp_reqname_tab[] = {"tsp_request_invalid",
 				 "tsp_request_generic",
 				 "tsp_request_open",
 				 "tsp_request_close",
@@ -85,7 +85,7 @@
 				 "tsp_request_last"
 };
 
-const char* tsp_reqhelp_tab[] = {"invalid tsp request",
+_EXPORT_TSP_COMMON const char* tsp_reqhelp_tab[] = {"invalid tsp request",
 				 "Generic interface to TSP request",
 				 "Send a TSP request open then close",
 				 "Same as request_open",
@@ -101,8 +101,8 @@
 				 "TSP LAST REQUEST"
 };
 #else
-extern const char* tsp_reqname_tab[];
-extern const char* tsp_reqhelp_tab[];
+_EXTERN_TSP_COMMON const char* tsp_reqname_tab[];
+_EXTERN_TSP_COMMON const char* tsp_reqhelp_tab[];
 #endif
 
 typedef struct TSP_request {
@@ -118,7 +118,7 @@
  * @param req 
  * @param req_type
  */
-void TSP_request_create(TSP_request_t* req, TSP_request_type_t req_type);
+_EXPORT_TSP_COMMON void TSP_request_create(TSP_request_t* req, TSP_request_type_t req_type);
 
 
 /** @} */
Index: src/core/driver/tsp_consumer.c
===================================================================
--- src/core/driver/tsp_consumer.c	(révision 4)
+++ src/core/driver/tsp_consumer.c	(révision 205)
@@ -307,6 +307,9 @@
   int found_stream_stop = FALSE;
   char* p;
   int32_t retcode = TSP_STATUS_OK;
+#if defined (WIN32)
+  WSADATA WSAData;
+#endif
 
   X_argv = (char**)calloc(*argc, sizeof(char*));
   X_argc = *argc;
@@ -392,6 +395,13 @@
   *argc = final_argc;
   *argv = X_argv;
 
+#if defined (WIN32)  
+  if (WSAStartup(MAKEWORD(2,2), &WSAData)) {
+	WSACleanup();
+	retcode = TSP_STATUS_NOK;
+   }
+#endif
+
   if (TSP_STATUS_OK==retcode) {
     X_tsp_init_ok = TRUE;
   } else {
@@ -404,12 +414,14 @@
 
 
 void 
-TSP_consumer_end(void) {	
+TSP_consumer_end() {	
 
   /* This is the end my friend ... the end ...*/
 
   /* Some day, we will find stuff to do here ;) */
-
+#if defined (WIN32)
+   WSACleanup();
+#endif
    /* By the way. do ->NOT<- free X_tsp_argv and X_argv,
      the main code may be using them... */
 
@@ -1060,8 +1072,12 @@
     
   TSP_otsp_t* otsp = (TSP_otsp_t*)arg;
   int is_fifo_full;  
-                    
+
+#if defined(WIN32)
+  STRACE_INFO(("Receiver thread started. Id=%u", (uint32_t)pthread_self().p)); 
+#else
   STRACE_INFO(("Receiver thread started. Id=%u", (uint32_t)pthread_self())); 
+#endif
 
   while(TRUE)
     {
@@ -1110,23 +1126,26 @@
       if(otsp->receiver)
 	{
 	  int status;
-
+	  
 	  /* Create receiver fifo */
 	  RINGBUF_PTR_INIT(TSP_sample_ringbuf_t,
 			   otsp->sample_fifo,
 			   TSP_sample_t,
 			   0,
 			   RINGBUF_SZ(TSP_CONSUMER_RINGBUF_SIZE) )
-	  	    
-	    
-	  /* Begin to receive */
-	  status = pthread_create(&(otsp->thread_receiver), 
-				  NULL,
-				  TSP_request_provider_thread_receiver,
-				  otsp);
 	  
-	  TSP_CHECK_THREAD(status, TSP_STATUS_ERROR_THREAD_CREATE);
-	  retcode = TSP_STATUS_OK;
+	  if (NULL==otsp->sample_fifo) {
+	    retcode = TSP_STATUS_ERROR_MEMORY_ALLOCATION;
+	  } else {	    	    	    
+	    /* Begin to receive */
+	    status = pthread_create(&(otsp->thread_receiver), 
+				    NULL,
+				    TSP_request_provider_thread_receiver,
+				    otsp);
+	    
+	    TSP_CHECK_THREAD(status, TSP_STATUS_ERROR_THREAD_CREATE);
+	    retcode = TSP_STATUS_OK;
+	  }
 	  
 	}
       else
Index: src/core/driver/tsp_stream_receiver.c
===================================================================
--- src/core/driver/tsp_stream_receiver.c	(révision 4)
+++ src/core/driver/tsp_stream_receiver.c	(révision 205)
@@ -37,10 +37,15 @@
 
 #include "tsp_sys_headers.h"
 
+#if defined (WIN32)
+#include <Windows.h>
+#include <WinSock2.h>
+#else
 #include <netdb.h>
 #include <netinet/in.h>
 #include <netinet/tcp.h>
 #include <sys/socket.h>
+#endif
 
 #ifndef SHUT_RDWR
 #define SHUT_RDWR 2
@@ -259,24 +264,34 @@
     {
       while ( bufferLen > 0)
 	{
-	  if ( (nread = read(identSocket, &buffer[Total], bufferLen)) < 0)
-	    {
+	  
+/* AP : Migration sous Windows */
+/* sous windows _errno est la variable globale */
+#ifdef WIN32
+		if ( (nread = recv(identSocket, &buffer[Total], bufferLen,0)) < 0)
+	  {
+          if( _errno == EINTR )
+#else
+		if ( (nread = read(identSocket, &buffer[Total], bufferLen)) < 0)
+	  {
 	      if( errno == EINTR )
-		{
-		  /* The read might have been interrupted by a signal */
-		  nread = 0;
-		}
+#endif
+		  {
+		    /* The read might have been interrupted by a signal */
+		    nread = 0;
+		  }
 	      else 
-		{
+		  {
 		  
-		  STRACE_INFO(("read failed"));
+		    STRACE_INFO(("read failed"));
+		    return FALSE;
+		  }
+	  }
+      else if (nread == 0)
+	  {
+		  STRACE_INFO(("Received socket EOF"));
 		  return FALSE;
-		}
-	    }else if (nread == 0)
-	      {
-		STRACE_INFO(("Received socket EOF"));
-		return FALSE;
-	      }
+	  }
 	  
 	  Total += nread;
 	  bufferLen -= nread;
Index: src/core/driver/tsp_consumer.h
===================================================================
--- src/core/driver/tsp_consumer.h	(révision 4)
+++ src/core/driver/tsp_consumer.h	(révision 205)
@@ -43,6 +43,17 @@
 #include <tsp_abs_types.h>
 #include <tsp_common.h>
 
+#undef _EXPORT_TSP_CONSUMER
+#if defined (WIN32) && defined (TSP_SHARED_LIBS)
+#  ifdef tsp_consumer_EXPORTS
+#    define _EXPORT_TSP_CONSUMER __declspec(dllexport) 
+#  else
+#    define _EXPORT_TSP_CONSUMER __declspec(dllimport) 
+#  endif
+#else
+#  define _EXPORT_TSP_CONSUMER
+#endif
+
 /**
  * @defgroup TSP_ConsumerLib Consumer Core Library
  * @ingroup TSP_CoreLib
@@ -132,7 +143,7 @@
  * @param argv Use the argv main arg before using it
  * @return TSP_STATUS_OK on success TSP_STATUS_ERROR_xxx on error.
  */
-int32_t 
+_EXPORT_TSP_CONSUMER int32_t 
 TSP_consumer_init(int* argc, char** argv[]);
 
 /**
@@ -140,7 +151,7 @@
  * call this function when you are done with the librairy.
  * This function must be called once.
  */
-void 
+_EXPORT_TSP_CONSUMER void 
 TSP_consumer_end();
 
 
@@ -188,7 +199,7 @@
 \t\tvoid, /, //, /// or :///   = rpc://localhost/(find any):(find first)     \n\
 \tOthers may have unpredictable results .. \n"
 
-TSP_provider_t TSP_consumer_connect_url(const char *url);
+_EXPORT_TSP_CONSUMER TSP_provider_t TSP_consumer_connect_url(const char *url);
 
 
 /** 
@@ -198,18 +209,18 @@
  * @param provider The provider handle
  * @return The provider name
  */				  
-const char* TSP_consumer_get_connected_name(TSP_provider_t provider);		
+_EXPORT_TSP_CONSUMER const char* TSP_consumer_get_connected_name(TSP_provider_t provider);		
 
 /**
  * Disconnect one given provider.
  * @param provider IN, the provider to be disconnected from.
  */ 
-void TSP_consumer_disconnect_one(TSP_provider_t provider);
+_EXPORT_TSP_CONSUMER void TSP_consumer_disconnect_one(TSP_provider_t provider);
 
 
 /** 
  * Ask the provider for a new consumer session.
- * This function must be called and must succed for the program to be able to call
+ * This function must be called and must succeed for the program to be able to call
  * other TSP_REQUEST_* functions.
  * @param provider The provider handle
  * @param custom_argc Custom provider data stream initialisation (optional : set 0)
@@ -232,7 +243,8 @@
  * It is a way to prevent the user from providing initialisation parameters thrue the command
  * line.
  */
-int32_t 
+
+_EXPORT_TSP_CONSUMER int32_t 
 TSP_consumer_request_open(TSP_provider_t provider, int custom_argc, char* custom_argv[]);
 
 /**
@@ -242,7 +254,7 @@
  * @param provider the TSP session to provider
  * @return the channel Id  if the session is open -1 if session not opened. 
  */
-uint32_t
+_EXPORT_TSP_CONSUMER uint32_t
 TSP_consumer_get_channel_id(TSP_provider_t provider);
 
 /**
@@ -250,7 +262,7 @@
  * @param provider The provider handle
  * @return TSP_STATUS_OK on success TSP_STATUS_ERROR_xxx on error.
  */
-int32_t
+_EXPORT_TSP_CONSUMER int32_t
 TSP_consumer_request_close(TSP_provider_t provider);
 
 
@@ -263,7 +275,7 @@
  * @param provider The provider handle
  * @return TSP_STATUS_OK on success TSP_STATUS_ERROR_xxx on error.
  */				  
-int32_t 
+_EXPORT_TSP_CONSUMER int32_t 
 TSP_consumer_request_information(TSP_provider_t provider);
 
 /** 
@@ -277,7 +289,7 @@
  * @param filter_string the filter string
  * @return TSP_STATUS_OK on success TSP_STATUS_ERROR_xxx on error.
  */				  
-int32_t 
+_EXPORT_TSP_CONSUMER int32_t 
 TSP_consumer_request_filtered_information(TSP_provider_t provider, int filter_kind, char* filter_string);
 
 /** 
@@ -290,7 +302,7 @@
  * @param[in] pgis_len the length of the pgis array
  * @return TSP_STATUS_OK on success TSP_STATUS_ERROR_xxx on error.
  */
-int32_t 
+_EXPORT_TSP_CONSUMER int32_t 
 TSP_consumer_request_extended_information(TSP_provider_t provider, int32_t* pgis, int32_t pgis_len);
 
 /** 
@@ -300,7 +312,7 @@
  * @param provider The provider handle
  * @return the provider extended information structure
  */
-const TSP_sample_symbol_extended_info_list_t*  
+_EXPORT_TSP_CONSUMER const TSP_sample_symbol_extended_info_list_t*  
 TSP_consumer_get_extended_information(TSP_provider_t provider);
 
 /** 
@@ -310,7 +322,7 @@
  * @param provider The provider handle
  * @return the provider information structure
  */				  
-const TSP_answer_sample_t* TSP_consumer_get_information(TSP_provider_t provider);
+_EXPORT_TSP_CONSUMER const TSP_answer_sample_t* TSP_consumer_get_information(TSP_provider_t provider);
 
 /** 
  * Ask the provider for a list of symbols.
@@ -326,7 +338,7 @@
  * @param symbols The request symbols list
  * @return TSP_STATUS_OK on success TSP_STATUS_ERROR_xxx on error.
  */				  
-int32_t 
+_EXPORT_TSP_CONSUMER int32_t 
 TSP_consumer_request_sample(TSP_provider_t provider,
 			    TSP_sample_symbol_info_list_t* symbols);
 
@@ -350,7 +362,7 @@
  * function is CPU friendlier (theoricaly at least...)
  * @return TSP_STATUS_OK on success TSP_STATUS_ERROR_xxx on error.
  */				      
-int32_t 
+_EXPORT_TSP_CONSUMER int32_t 
 TSP_consumer_request_sample_init(TSP_provider_t provider, TSP_sample_callback_t callback, void* user_data);    
 
 /** 
@@ -358,7 +370,7 @@
  * @param provider The provider handle
  * @return TSP_STATUS_OK on success TSP_STATUS_ERROR_xxx on error.
  */				      
-int32_t
+_EXPORT_TSP_CONSUMER int32_t
 TSP_consumer_request_sample_destroy(TSP_provider_t provider);    
 
 /** 
@@ -374,7 +386,7 @@
  *  - When the other types will be implemented (RAW, STRING) the TSP_sample_t
  *    type will not work anymore as it is double specific for now.
  */				          
-int32_t 
+_EXPORT_TSP_CONSUMER int32_t 
 TSP_consumer_read_sample(TSP_provider_t provider,
 			 TSP_sample_t* sample,
 			 int* new_sample);
@@ -386,7 +398,7 @@
  * @param[in] async_sample_write the async write message itself
  * @return TSP_STATUS_OK on success other TSP_STATUS_ERROR on failure.
  */
-int32_t 
+_EXPORT_TSP_CONSUMER int32_t 
 TSP_consumer_request_async_sample_write(TSP_provider_t provider,
 					TSP_consumer_async_sample_t* async_sample_write);
 
@@ -398,7 +410,7 @@
  *                on return contains the read value (if success)
  * @return TSP_STATUS_OK on success other TSP_STATUS_ERROR on failure.
  */
-int32_t 
+_EXPORT_TSP_CONSUMER int32_t 
 TSP_consumer_request_async_sample_read(TSP_provider_t provider,
 				       TSP_consumer_async_sample_t* async_sample_read);
 
Index: src/core/misc_utils/tsp_services.h
===================================================================
--- src/core/misc_utils/tsp_services.h	(révision 0)
+++ src/core/misc_utils/tsp_services.h	(révision 205)
@@ -0,0 +1,51 @@
+/*
+
+$Header:$
+
+-----------------------------------------------------------------------
+
+TSP Library - core components for a generic Transport Sampling Protocol.
+
+Copyright (c) 2002 Alan PRAT 
+
+This library is free software; you can redistribute it and/or
+modify it under the terms of the GNU Lesser General Public
+License as published by the Free Software Foundation; either
+version 2.1 of the License, or (at your option) any later version.
+
+This library is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+Lesser General Public License for more details.
+
+You should have received a copy of the GNU Lesser General Public
+License along with this library; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+-----------------------------------------------------------------------
+
+Project   : TSP
+Maintainer : tsp@astrium-space.com
+Component : Services
+
+-----------------------------------------------------------------------
+
+Purpose   : Interface for tsp services functions
+
+-----------------------------------------------------------------------
+ */
+#ifndef _TSP_SERVICES_H
+#define _TSP_SERVICES_H
+
+#undef _EXPORT_TSP_SERVICES
+#if defined (WIN32) && defined (TSP_SHARED_LIBS)
+#  ifdef tsp_services_EXPORTS
+#    define _EXPORT_TSP_SERVICES __declspec(dllexport) 
+#  else
+#    define _EXPORT_TSP_SERVICES __declspec(dllimport) 
+#  endif
+#else
+#  define _EXPORT_TSP_SERVICES
+#endif
+
+#endif
Index: src/core/misc_utils/tsp_mtgprof.c
===================================================================
--- src/core/misc_utils/tsp_mtgprof.c	(révision 4)
+++ src/core/misc_utils/tsp_mtgprof.c	(révision 205)
@@ -20,7 +20,11 @@
     /* Initialize the wrapper structure */
     wrapper_data.start_routine = start_routine;
     wrapper_data.arg = arg;
+#if defined (WIN32)
+    /* FIXME under Windows : interval timer */
+#else
     getitimer(ITIMER_PROF, &wrapper_data.itimer);
+#endif
     pthread_cond_init(&wrapper_data.wait, NULL);
     pthread_mutex_init(&wrapper_data.lock, NULL);
     pthread_mutex_lock(&wrapper_data.lock);
@@ -51,7 +55,11 @@
     void * arg = ((wrapper_t*)data)->arg;
 
     /* Set the profile timer value */
+#if defined (WIN32)
+    /* FIXME under Windows : interval timer */
+#else
     setitimer(ITIMER_PROF, &((wrapper_t*)data)->itimer, NULL);
+#endif
 
     /* Tell the calling thread that we don't need its data anymore */
     pthread_mutex_lock(&((wrapper_t*)data)->lock);
Index: src/core/misc_utils/tsp_time.c
===================================================================
--- src/core/misc_utils/tsp_time.c	(révision 4)
+++ src/core/misc_utils/tsp_time.c	(révision 205)
@@ -35,13 +35,16 @@
 -----------------------------------------------------------------------
  */
 
-#include "tsp_sys_headers.h"
 #include <time.h>
 
-#include "tsp_time.h"
+#include "tsp_sys_headers.h"
 
+#include "tsp_time.h"
 
-tsp_hrtime_t tsp_gethrtime(void)
+#if defined (WIN32)
+#include <rpc/rpc.h>
+#endif
+tsp_hrtime_t tsp_gethrtime()
 {
 #ifdef TSP_SYSTEM_HAVE_GETHRTIME
   return gethrtime();
@@ -67,7 +70,14 @@
 #ifdef TSP_SYSTEM_HAVE_THREADSAFE_USLEEP
   return usleep(useconds);
 #else
+  
+#ifdef TSP_SYSTEM_USE_WIN32_SLEEP
+  Sleep(useconds / 1000);
+  return 0;
+#else
   ERROR__you_should_try_to_find_some_kind_of_wait_function
+#endif /*TSP_SYSTEM_HAVE_SLEEP*/
+
 #endif /*TSP_SYSTEM_HAVE_THREADSAFE_USLEEP*/
 
 #endif /*TSP_SYSTEM_HAVE_NANOSLEEP*/
Index: src/core/misc_utils/tsp_ringbuf.h
===================================================================
--- src/core/misc_utils/tsp_ringbuf.h	(révision 4)
+++ src/core/misc_utils/tsp_ringbuf.h	(révision 205)
@@ -231,17 +231,19 @@
 
 
 
-#define RINGBUF_PTR_INIT(TypeName, name, ItemType, nbSpareBytes, sz) \
-	{ \
-          int mul_offset =  RINGBUF_MULTSUP((sizeof(ItemType) + nbSpareBytes),sizeof(ItemType)) / sizeof(ItemType);\
-	  name = (TypeName*)malloc(sizeof(TypeName) + (sizeof(ItemType) * mul_offset  * sz)); \
-	  (name)->size   = sz; \
-	  (name)->put   = 0; \
-	  (name)->get   = 0; \
-	  (name)->missed = 0; \
-          (name)->mul_offset = mul_offset; \
-          (name)->buf = (ItemType*)((name)+1); \
-	}
+#define RINGBUF_PTR_INIT(TypeName, name, ItemType, nbSpareBytes, sz)	\
+  {									\
+    int mul_offset =  RINGBUF_MULTSUP((sizeof(ItemType) + nbSpareBytes),sizeof(ItemType)) / sizeof(ItemType); \
+    name = (TypeName*)malloc(sizeof(TypeName) + (sizeof(ItemType) * mul_offset  * sz)); \
+    if(NULL!=name) {							\
+      (name)->size   = sz;						\
+      (name)->put   = 0;						\
+      (name)->get   = 0;						\
+      (name)->missed = 0;						\
+      (name)->mul_offset = mul_offset;					\
+      (name)->buf = (ItemType*)((name)+1);				\
+    }									\
+  }
 
 #define RINGBUF_PTR_DESTROY(name)  \
 	{ \
